/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.119 Revision 1.216
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.119 2005/04/12 12:28:14 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.216 2008/11/13 23:50:55 mpagano Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2005 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
22# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# the patchset version for 31# the patchset version for
30# and not use it as a true package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36# 39#
37# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
38# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
39 48
40# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
41# can be supported by the headers ebuild 50# can be supported by the headers ebuild
42 51
43# UNIPATCH_LIST - space delimetered list of patches to be applied to the 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
49# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
50# the doc dir 59# the doc dir
51# UNIPATCH_STRICTORDER - if this is set places patches into directories of 60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
52# order, so they are applied in the order passed 61# order, so they are applied in the order passed
53 62
54inherit toolchain-funcs versionator multilib 63inherit eutils toolchain-funcs versionator multilib
55ECLASS="kernel-2"
56INHERITED="$INHERITED $ECLASS"
57EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
58 pkg_preinst pkg_postinst 65
66# Added by Daniel Ostrow <dostrow@gentoo.org>
67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
68# I will remove it when I come up with something more reasonable.
69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
59 70
60export CTARGET=${CTARGET:-${CHOST}} 71export CTARGET=${CTARGET:-${CHOST}}
61if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
62 export CTARGET=${CATEGORY/cross-} 73 export CTARGET=${CATEGORY/cross-}
63fi 74fi
64 75
65HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
66LICENSE="GPL-2" 77LICENSE="GPL-2"
67 78
79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
80RESTRICT="binchecks strip"
81
68# set LINUX_HOSTCFLAGS if not already set 82# set LINUX_HOSTCFLAGS if not already set
69[ -z "$LINUX_HOSTCFLAGS" ] && \ 83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
70 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
71 85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
105
72#Eclass functions only from here onwards ... 106#Eclass functions only from here onwards ...
73#============================================================== 107#==============================================================
108handle_genpatches() {
109 local tarball
110 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1
111
112 for i in ${K_WANT_GENPATCHES} ; do
113 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
114 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
115 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
116 done
117}
118
74detect_version() { 119detect_version() {
75 # this function will detect and set 120 # this function will detect and set
76 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 121 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
77 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 122 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
78 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 123 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
113 158
114 RELEASE=${CKV/${OKV}} 159 RELEASE=${CKV/${OKV}}
115 RELEASE=${RELEASE/_beta} 160 RELEASE=${RELEASE/_beta}
116 RELEASE=${RELEASE/_rc/-rc} 161 RELEASE=${RELEASE/_rc/-rc}
117 RELEASE=${RELEASE/_pre/-pre} 162 RELEASE=${RELEASE/_pre/-pre}
118 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-bk} 163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
119 RELEASETYPE=${RELEASE//[0-9]} 164 RELEASETYPE=${RELEASE//[0-9]}
120 165
121 # Now we know that RELEASE is the -rc/-bk 166 # Now we know that RELEASE is the -rc/-git
122 # and RELEASETYPE is the same but with its numerics stripped 167 # and RELEASETYPE is the same but with its numerics stripped
123 # we can work on better sorting EXTRAVERSION. 168 # we can work on better sorting EXTRAVERSION.
124 # first of all, we add the release 169 # first of all, we add the release
125 EXTRAVERSION="${RELEASE}" 170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
126 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
127 173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
128 if [[ -n ${K_PREPATCHED} ]]; then 178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
129 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
130 elif [[ "${ETYPE}" = "sources" ]]; then 181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
131 # For some sources we want to use the PV in the extra version 183 # For some sources we want to use the PV in the extra version
132 # This is because upstream releases with a completely different 184 # This is because upstream releases with a completely different
133 # versioning scheme. 185 # versioning scheme.
134 case ${PN/-*} in 186 case ${PN/-*} in
135 wolk) K_USEPV=1;; 187 wolk) K_USEPV=1;;
136 vserver) K_USEPV=1;; 188 vserver) K_USEPV=1;;
137 esac 189 esac
138 190
139 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
140 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
141 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
196
197 # The only messing around which should actually effect this is for KV_EXTRA
198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
200 if [[ -n ${KV_EXTRA} ]]; then
201 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
202 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
142 fi 205 fi
143 206
144 # We need to set this using OKV, but we need to set it before we do any 207 # We need to set this using OKV, but we need to set it before we do any
145 # messing around with OKV based on RELEASETYPE 208 # messing around with OKV based on RELEASETYPE
146 KV_FULL=${OKV}${EXTRAVERSION} 209 KV_FULL=${OKV}${EXTRAVERSION}
147 210
148 # we will set this for backwards compatibility. 211 # we will set this for backwards compatibility.
149 S=${WORKDIR}/linux-${KV_FULL} 212 S=${WORKDIR}/linux-${KV_FULL}
150 KV=${KV_FULL} 213 KV=${KV_FULL}
151 214
152 # -rc-bk pulls can be achieved by specifying CKV 215 # -rc-git pulls can be achieved by specifying CKV
153 # for example: 216 # for example:
154 # CKV="2.6.11_rc3_pre2" 217 # CKV="2.6.11_rc3_pre2"
155 # will pull: 218 # will pull:
156 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2 219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
157 220
158 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
159 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
160 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
161 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
162 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
163 fi 226 fi
164 227
165 if [[ ${RELEASETYPE} == -bk ]]; then 228 if [[ ${RELEASETYPE} == -git ]]; then
166 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
167 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
168 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
169 fi 232 fi
170 233
171 if [[ ${RELEASETYPE} == -rc-bk ]]; then 234 if [[ ${RELEASETYPE} == -rc-git ]]; then
172 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
173 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
174 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
175 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
176 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
177 fi 240 fi
178 241
179 if [[ -n ${KV_EXTRA} ]]; then 242 debug-print-kernel2-variables
180 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 243
181 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 244 handle_genpatches
182 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
183 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
184 fi
185} 245}
186 246
187kernel_is() { 247kernel_is() {
188 [[ -z ${OKV} ]] && detect_version 248 [[ -z ${OKV} ]] && detect_version
189 local operator test value x=0 y=0 z=0 249 local operator test value x=0 y=0 z=0
190 250
191 case ${1} in 251 case ${1} in
192 lt) operator="-lt"; shift;; 252 lt) operator="-lt"; shift;;
193 gt) operator="-gt"; shift;; 253 gt) operator="-gt"; shift;;
199 259
200 for x in ${@}; do 260 for x in ${@}; do
201 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 261 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
202 value="${value}${x}" 262 value="${value}${x}"
203 z=$((${z} + 1)) 263 z=$((${z} + 1))
204 264
205 case ${z} in 265 case ${z} in
206 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done; 266 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
207 test="${test}${KV_MAJOR}";; 267 test="${test}${KV_MAJOR}";;
208 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done; 268 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
209 test="${test}${KV_MINOR}";; 269 test="${test}${KV_MINOR}";;
222 282
223kernel_is_2_6() { 283kernel_is_2_6() {
224 kernel_is 2 6 || kernel_is 2 5 284 kernel_is 2 6 || kernel_is 2 5
225} 285}
226 286
227kernel_header_destdir() {
228 [[ ${CTARGET} == ${CHOST} ]] \
229 && echo /usr/include \
230 || echo /usr/${CTARGET}/include
231}
232
233# Capture the sources type and set DEPENDs 287# Capture the sources type and set DEPENDs
234if [[ ${ETYPE} == sources ]]; then 288if [[ ${ETYPE} == sources ]]; then
235 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
236 >=sys-devel/binutils-2.11.90.0.31 ) 290 >=sys-devel/binutils-2.11.90.0.31 )"
237 doc? ( app-text/docbook-sgml-utils )"
238 RDEPEND="${DEPEND}
239 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
240 sys-devel/make )" 292 sys-devel/make )
293 virtual/dev-manager"
241 294
242 PROVIDE="virtual/linux-sources" 295 PROVIDE="virtual/linux-sources"
243 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
297
244 SLOT="${PVR}" 298 SLOT="${PVR}"
245 DESCRIPTION="Sources for the Linux kernel" 299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
246 IUSE="${IUSE} symlink build doc" 300 IUSE="symlink build"
247elif [[ ${ETYPE} == headers ]]; then 301elif [[ ${ETYPE} == headers ]]; then
248 DESCRIPTION="Linux system headers" 302 DESCRIPTION="Linux system headers"
249 IUSE="${IUSE}" 303
250 304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
307
251 if [[ ${CTARGET} = ${CHOST} ]]; then 308 if [[ ${CTARGET} = ${CHOST} ]]; then
252 DEPEND="!virtual/os-headers" 309 DEPEND="!virtual/os-headers"
253 PROVIDE="virtual/kernel virtual/os-headers" 310 PROVIDE="virtual/os-headers"
254 SLOT="0" 311 SLOT="0"
255 else 312 else
256 SLOT="${CTARGET}" 313 SLOT="${CTARGET}"
257 fi 314 fi
258else 315else
259 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
260 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
261fi 318fi
262 319
320# Cross-compile support functions
321#==============================================================
322kernel_header_destdir() {
323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
326}
327
328cross_pre_c_headers() {
329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
330}
331
332env_setup_xmakeopts() {
333 # Kernel ARCH != portage ARCH
334 export KARCH=$(tc-arch-kernel)
335
336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
337 # variables properly or bad things happen !
338 xmakeopts="ARCH=${KARCH}"
339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
341 elif type -p ${CHOST}-ar > /dev/null ; then
342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
343 fi
344 export xmakeopts
345}
346
263# Unpack functions 347# Unpack functions
264#============================================================== 348#==============================================================
265unpack_2_4() { 349unpack_2_4() {
266 # Kernel ARCH != portage ARCH
267 local ARCH=$(tc-arch-kernel)
268
269 cd ${S}
270 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
271 # so we autogenerate it 351 # so we autogenerate it
272 make mrproper || die "make mrproper died" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
273 make include/linux/version.h || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
274 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
356}
275 357
276 ARCH=$(tc-arch) 358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
277} 377}
278 378
279universal_unpack() { 379universal_unpack() {
280 cd ${WORKDIR} 380 cd ${WORKDIR}
281 unpack linux-${OKV}.tar.bz2 381 unpack linux-${OKV}.tar.bz2
382 if [[ -d "linux" ]]; then
383 mv linux linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
282 if [[ "${OKV}" != "${KV_FULL}" ]]; then 385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
283 mv linux-${OKV} linux-${KV_FULL} \ 386 mv linux-${OKV} linux-${KV_FULL} \
284 || die "Unable to move source tree to ${KV_FULL}." 387 || die "Unable to move source tree to ${KV_FULL}."
285 fi 388 fi
286 cd ${S} 389 cd "${S}"
287 390
288 # remove all backup files 391 # remove all backup files
289 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
290 393
291 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
292 use ppc && \ 395 # only do this for kernel < 2.6.27 since this file does not exist in later
396 # kernels
397 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
398 then
399 sed -i \
293 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 400 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
294 ${S}/arch/ppc/Makefile 401 "${S}"/arch/ppc/Makefile
402 else
403 sed -i \
404 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
405 "${S}"/arch/powerpc/Makefile
406 fi
295} 407}
296 408
297unpack_set_extraversion() { 409unpack_set_extraversion() {
298 cd ${S} 410 cd "${S}"
299 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 411 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
300 cd ${OLDPWD} 412 cd "${OLDPWD}"
301} 413}
302 414
303# Should be done after patches have been applied 415# Should be done after patches have been applied
304# Otherwise patches that modify the same area of Makefile will fail 416# Otherwise patches that modify the same area of Makefile will fail
305unpack_fix_install_path() { 417unpack_fix_install_path() {
306 cd ${S} 418 cd "${S}"
307 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 419 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
308} 420}
309 421
310unpack_fix_docbook() {
311 if [[ -d ${S}/Documentation/DocBook ]]; then
312 cd ${S}/Documentation/DocBook
313 sed -ie "s:db2:docbook2:g" Makefile
314 cd ${OLDPWD}
315 fi
316}
317
318# Compile Functions 422# Compile Functions
319#============================================================== 423#==============================================================
320compile_headers() { 424compile_headers() {
425 env_setup_xmakeopts
426
321 # if we couldnt obtain HOSTCFLAGS from the Makefile, 427 # if we couldnt obtain HOSTCFLAGS from the Makefile,
322 # then set it to something sane 428 # then set it to something sane
323 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS ${S}/Makefile) 429 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
324 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 430 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
325
326 # Kernel ARCH != portage ARCH
327 local KARCH=$(tc-arch-kernel)
328
329 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
330 # variables properly or bad things happen !
331 local xmakeopts="ARCH=${KARCH}"
332 if [[ ${CTARGET} != ${CHOST} ]]; then
333 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
334 elif type -p ${CHOST}-ar; then
335 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
336 fi
337 431
338 if kernel_is 2 4; then 432 if kernel_is 2 4; then
339 yes "" | make oldconfig ${xmakeopts} 433 yes "" | make oldconfig ${xmakeopts}
340 echo ">>> make oldconfig complete" 434 echo ">>> make oldconfig complete"
341 use sparc && make dep ${xmakeopts} 435 make dep ${xmakeopts}
342 elif kernel_is 2 6; then 436 elif kernel_is 2 6; then
437 # 2.6.18 introduces headers_install which means we dont need any
438 # of this crap anymore :D
439 kernel_is ge 2 6 18 && return 0
440
343 # autoconf.h isnt generated unless it already exists. plus, we have 441 # autoconf.h isnt generated unless it already exists. plus, we have
344 # no guarantee that any headers are installed on the system... 442 # no guarantee that any headers are installed on the system...
345 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 443 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
346 || touch include/linux/autoconf.h 444 || touch include/linux/autoconf.h
347 445
348 # if K_DEFCONFIG isn't set, force to "defconfig" 446 # if K_DEFCONFIG isn't set, force to "defconfig"
349 # needed by mips 447 # needed by mips
350 if [[ -z ${K_DEFCONFIG} ]]; then 448 if [[ -z ${K_DEFCONFIG} ]]; then
449 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
450 case ${CTARGET} in
451 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
452 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
453 *) K_DEFCONFIG="defconfig";;
454 esac
455 else
351 K_DEFCONFIG="defconfig" 456 K_DEFCONFIG="defconfig"
457 fi
352 fi 458 fi
353 459
354 # if there arent any installed headers, then there also isnt an asm 460 # if there arent any installed headers, then there also isnt an asm
355 # symlink in /usr/include/, and make defconfig will fail, so we have 461 # symlink in /usr/include/, and make defconfig will fail, so we have
356 # to force an include path with $S. 462 # to force an include path with $S.
357 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 463 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
358 ln -sf asm-${KARCH} "${S}"/include/asm 464 ln -sf asm-${KARCH} "${S}"/include/asm
465 cross_pre_c_headers && return 0
466
359 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 467 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
468 if compile_headers_tweak_config ; then
469 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
470 fi
360 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 471 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
361 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 472 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
362 fi 473 fi
363} 474}
364 475
365compile_manpages() { 476compile_headers_tweak_config() {
366 einfo "Making manpages ..." 477 # some targets can be very very picky, so let's finesse the
367 env -u ARCH make mandocs 478 # .config based upon any info we may have
479 case ${CTARGET} in
480 sh*)
481 sed -i '/CONFIG_CPU_SH/d' .config
482 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
483 return 0;;
484 esac
485
486 # no changes, so lets do nothing
487 return 1
368} 488}
369 489
370# install functions 490# install functions
371#============================================================== 491#==============================================================
372install_universal() { 492install_universal() {
373 #fix silly permissions in tarball 493 #fix silly permissions in tarball
374 cd ${WORKDIR} 494 cd ${WORKDIR}
375 chown -R root:root * 495 chown -R root:0 *
376 chmod -R a+r-w+X,u+w * 496 chmod -R a+r-w+X,u+w *
377 cd ${OLDPWD} 497 cd ${OLDPWD}
378} 498}
379 499
380install_headers() { 500install_headers() {
381 local ddir=$(kernel_header_destdir) 501 local ddir=$(kernel_header_destdir)
382 502
503 # 2.6.18 introduces headers_install which means we dont need any
504 # of this crap anymore :D
505 if kernel_is ge 2 6 18 ; then
506 env_setup_xmakeopts
507 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
508
509 # let other packages install some of these headers
510 rm -rf "${D}"/${ddir}/sound #alsa-headers
511 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
512 return 0
513 fi
514
515 # Do not use "linux/*" as that can cause problems with very long
516 # $S values where the cmdline to cp is too long
383 cd ${S} 517 cd "${S}"
384 dodir ${ddir}/linux 518 dodir ${ddir}/linux
385 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux 519 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
386 rm -rf ${D}/${ddir}/linux/modules 520 rm -rf "${D}"/${ddir}/linux/modules
387 521
388 # Handle multilib headers 522 # Handle multilib headers and crap
523 local multi_dirs="" multi_defs=""
389 case $(tc-arch-kernel) in 524 case $(tc-arch-kernel) in
390 sparc64) 525 sparc64)
391 dodir ${ddir}/asm-sparc 526 multi_dirs="sparc sparc64"
392 cp -ax ${S}/include/asm-sparc/* ${D}/${ddir}/asm-sparc 527 multi_defs="!__arch64__ __arch64__"
393
394 dodir ${ddir}/asm-sparc64
395 cp -ax ${S}/include/asm-sparc64/* ${D}/${ddir}/asm-sparc64
396
397 create_ml_includes ${ddir}/asm !__arch64__:${ddir}/asm-sparc __arch64__:${ddir}/asm-sparc64
398 ;; 528 ;;
399 x86_64) 529 x86_64)
400 dodir ${ddir}/asm-i386 530 multi_dirs="i386 x86_64"
401 cp -ax ${S}/include/asm-i386/* ${D}/${ddir}/asm-i386 531 multi_defs="__i386__ __x86_64__"
402 532 ;;
403 dodir ${ddir}/asm-x86_64 533 ppc64)
404 cp -ax ${S}/include/asm-x86_64/* ${D}/${ddir}/asm-x86_64 534 multi_dirs="ppc ppc64"
405 535 multi_defs="!__powerpc64__ __powerpc64__"
406 create_ml_includes ${ddir}/asm __i386__:${ddir}/asm-i386 __x86_64__:${ddir}/asm-x86_64 536 ;;
537 s390x)
538 multi_dirs="s390 s390x"
539 multi_defs="!__s390x__ __s390x__"
407 ;; 540 ;;
408 arm) 541 arm)
409 dodir ${ddir}/asm 542 dodir ${ddir}/asm
410 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 543 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
411 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -s arch-ebsa285 ${D}/${ddir}/asm/arch 544 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
412 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -s proc-armv ${D}/${ddir}/asm/proc 545 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
546 ;;
547 powerpc)
548 dodir ${ddir}/asm
549 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
550 if [[ -e "${S}"/include/asm-ppc ]] ; then
551 dodir ${ddir}/asm-ppc
552 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
553 fi
413 ;; 554 ;;
414 *) 555 *)
415 dodir ${ddir}/asm 556 dodir ${ddir}/asm
416 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 557 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
417 ;; 558 ;;
418 esac 559 esac
560 if [[ -n ${multi_dirs} ]] ; then
561 local d ml_inc=""
562 for d in ${multi_dirs} ; do
563 dodir ${ddir}/asm-${d}
564 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
565
566 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
567 multi_defs=${multi_defs#* }
568 done
569 create_ml_includes ${ddir}/asm ${ml_inc}
570 fi
419 571
420 if kernel_is 2 6; then 572 if kernel_is 2 6; then
421 dodir ${ddir}/asm-generic 573 dodir ${ddir}/asm-generic
422 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic 574 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
423 fi 575 fi
424 576
425 # clean up 577 # clean up
426 find "${D}" -name '*.orig' -exec rm -f {} \; 578 find "${D}" -name '*.orig' -exec rm -f {} \;
427 579
428 cd ${OLDPWD} 580 cd ${OLDPWD}
429} 581}
430 582
431install_sources() { 583install_sources() {
432 local doc docs file 584 local file
433 585
434 cd ${S} 586 cd "${S}"
435 dodir /usr/src 587 dodir /usr/src
436 echo ">>> Copying sources ..." 588 echo ">>> Copying sources ..."
437 589
438 file="$(find ${WORKDIR} -iname "docs" -type d)" 590 file="$(find ${WORKDIR} -iname "docs" -type d)"
439 if [[ -n ${file} ]]; then 591 if [[ -n ${file} ]]; then
440 for file in $(find ${file} -type f); do 592 for file in $(find ${file} -type f); do
441 echo "${file//*docs\/}" >> ${S}/patches.txt 593 echo "${file//*docs\/}" >> "${S}"/patches.txt
442 echo "===================================================" >> ${S}/patches.txt 594 echo "===================================================" >> "${S}"/patches.txt
443 cat ${file} >> ${S}/patches.txt 595 cat ${file} >> "${S}"/patches.txt
444 echo "===================================================" >> ${S}/patches.txt 596 echo "===================================================" >> "${S}"/patches.txt
445 echo "" >> ${S}/patches.txt 597 echo "" >> "${S}"/patches.txt
446 done 598 done
447 fi 599 fi
448 600
449 if [[ ! -f ${S}/patches.txt ]]; then 601 if [[ ! -f ${S}/patches.txt ]]; then
450 # patches.txt is empty so lets use our ChangeLog 602 # patches.txt is empty so lets use our ChangeLog
451 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 603 [[ -f ${FILESDIR}/../ChangeLog ]] && \
452 echo "Please check the ebuild ChangeLog for more details." \ 604 echo "Please check the ebuild ChangeLog for more details." \
453 > ${S}/patches.txt 605 > "${S}"/patches.txt
454 fi 606 fi
455
456 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
457 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
458 use doc && ! use arm && ! use s390 && install_manpages
459 dodoc ${docs}
460 607
461 mv ${WORKDIR}/linux* ${D}/usr/src 608 mv ${WORKDIR}/linux* ${D}/usr/src
462}
463
464install_manpages() {
465 sed -ie "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
466 ebegin "Installing manpages"
467 env -u ARCH make installmandocs
468 eend $?
469 sed -ie "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
470} 609}
471 610
472# pkg_preinst functions 611# pkg_preinst functions
473#============================================================== 612#==============================================================
474preinst_headers() { 613preinst_headers() {
479 618
480# pkg_postinst functions 619# pkg_postinst functions
481#============================================================== 620#==============================================================
482postinst_sources() { 621postinst_sources() {
483 local MAKELINK=0 622 local MAKELINK=0
484 623
485 # if we have USE=symlink, then force K_SYMLINK=1 624 # if we have USE=symlink, then force K_SYMLINK=1
486 use symlink && K_SYMLINK=1 625 use symlink && K_SYMLINK=1
487 626
488 # if we are to forcably symlink, delete it if it already exists first. 627 # if we are to forcably symlink, delete it if it already exists first.
489 if [[ -n ${K_SYMLINK} ]]; then 628 if [[ ${K_SYMLINK} > 0 ]]; then
490 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 629 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
491 MAKELINK=1 630 MAKELINK=1
492 fi 631 fi
493 632
494 # if the link doesnt exist, lets create it 633 # if the link doesnt exist, lets create it
495 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 634 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
496 635
497 if [[ ${MAKELINK} == 1 ]]; then 636 if [[ ${MAKELINK} == 1 ]]; then
498 cd ${ROOT}usr/src 637 cd ${ROOT}usr/src
499 ln -sf linux-${KV_FULL} linux 638 ln -sf linux-${KV_FULL} linux
500 cd ${OLDPWD} 639 cd ${OLDPWD}
501 fi 640 fi
502 641
503 # Don't forget to make directory for sysfs 642 # Don't forget to make directory for sysfs
504 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 643 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
505 644
506 echo 645 echo
507 einfo "After installing a new kernel of any version, it is important"
508 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
509 einfo "created (X.Y is the first 2 parts of your new kernel version)"
510 echo
511 einfo "For example, this kernel will require:"
512 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
513 echo
514 einfo "If you are upgrading from a previous kernel, you may be interested" 646 elog "If you are upgrading from a previous kernel, you may be interested"
515 einfo "in the following documents:" 647 elog "in the following document:"
516 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 648 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
517 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
518 echo 649 echo
519 650
520 # if K_EXTRAEINFO is set then lets display it now 651 # if K_EXTRAEINFO is set then lets display it now
521 if [[ -n ${K_EXTRAEINFO} ]]; then 652 if [[ -n ${K_EXTRAEINFO} ]]; then
522 echo ${K_EXTRAEINFO} | fmt | 653 echo ${K_EXTRAEINFO} | fmt |
523 while read -s ELINE; do einfo "${ELINE}"; done 654 while read -s ELINE; do einfo "${ELINE}"; done
524 fi 655 fi
525 656
657 # if K_EXTRAELOG is set then lets display it now
658 if [[ -n ${K_EXTRAELOG} ]]; then
659 echo ${K_EXTRAELOG} | fmt |
660 while read -s ELINE; do elog "${ELINE}"; done
661 fi
662
526 # if K_EXTRAEWARN is set then lets display it now 663 # if K_EXTRAEWARN is set then lets display it now
527 if [[ -n ${K_EXTRAEWARN} ]]; then 664 if [[ -n ${K_EXTRAEWARN} ]]; then
528 echo ${K_EXTRAEWARN} | fmt | 665 echo ${K_EXTRAEWARN} | fmt |
529 while read -s ELINE; do ewarn "${ELINE}"; done 666 while read -s ELINE; do ewarn "${ELINE}"; done
530 fi 667 fi
668
669 # optionally display security unsupported message
670 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
671 echo
672 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
673 ewarn "This means that it is likely to be vulnerable to recent security issues."
674 ewarn "For specific information on why this kernel is unsupported, please read:"
675 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
676 fi
677
678 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
679 KV_MAJOR=$(get_version_component_range 1 ${OKV})
680 KV_MINOR=$(get_version_component_range 2 ${OKV})
681 KV_PATCH=$(get_version_component_range 3 ${OKV})
682 if [[ "$(tc-arch)" = "sparc" ]] \
683 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
684 then
685 echo
686 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
687 elog "you now need to do"
688 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
689 elog "instead of just"
690 elog " make"
691 elog "to compile the kernel. For more information please browse to"
692 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
693 echo
694 fi
531} 695}
532 696
533postinst_headers() { 697postinst_headers() {
534 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 698 elog "Kernel headers are usually only used when recompiling your system libc, as"
535 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 699 elog "such, following the installation of newer headers, it is advised that you"
536 einfo "emerge glibc" 700 elog "re-merge your system libc."
537 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 701 elog "Failure to do so will cause your system libc to not make use of newer"
538 einfo "headers." 702 elog "features present in the updated kernel headers."
539} 703}
540 704
541# pkg_setup functions 705# pkg_setup functions
542#============================================================== 706#==============================================================
543setup_headers() { 707setup_headers() {
557 721
558# unipatch 722# unipatch
559#============================================================== 723#==============================================================
560unipatch() { 724unipatch() {
561 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 725 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
562 local STRICT_COUNT PATCH_LEVEL myLC_ALL 726 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
563 727
564 # set to a standard locale to ensure sorts are ordered properly. 728 # set to a standard locale to ensure sorts are ordered properly.
565 myLC_ALL="${LC_ALL}" 729 myLC_ALL="${LC_ALL}"
730 myLANG="${LANG}"
566 LC_ALL="C" 731 LC_ALL="C"
732 LANG=""
567 733
568 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 734 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
569 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 735 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
570 736
571 # We're gonna need it when doing patches with a predefined patchlevel 737 # We're gonna need it when doing patches with a predefined patchlevel
738 extglob_bak=$(shopt -p extglob)
572 shopt -s extglob 739 shopt -s extglob
573 740
574 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 741 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
575 # usage can be either via an env var or by params 742 # usage can be either via an env var or by params
576 # although due to the nature we pass this within this eclass 743 # although due to the nature we pass this within this eclass
578 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 745 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
579 UNIPATCH_LIST="${@}" 746 UNIPATCH_LIST="${@}"
580 747
581 #unpack any passed tarballs 748 #unpack any passed tarballs
582 for i in ${UNIPATCH_LIST}; do 749 for i in ${UNIPATCH_LIST}; do
583 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 750 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
584 extention=${i/*./}
585 extention=${extention/:*/}
586 case ${extention} in
587 tbz2) PIPE_CMD="tar -xvjf";;
588 bz2) PIPE_CMD="tar -xvjf";;
589 tgz) PIPE_CMD="tar -xvzf";;
590 gz) PIPE_CMD="tar -xvzf";;
591 *) eerror "Unrecognized tarball compression"
592 die "Unrecognized tarball compression";;
593 esac
594
595 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 751 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
596 unset z 752 unset z
597 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 753 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
598 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 754 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
599 do z="${z}0"; 755 do z="${z}0";
600 done 756 done
601 PATCH_ORDER="${z}${STRICT_COUNT}" 757 PATCH_ORDER="${z}${STRICT_COUNT}"
602 758
603 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 759 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
604 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 760 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
761 unpack ${i##*/}
762 popd >/dev/null
605 else 763 else
606 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 764 pushd "${KPATCH_DIR}" >/dev/null
765 unpack ${i##*/}
766 popd >/dev/null
607 fi 767 fi
608 768
609 if [ $? == 0 ]; then
610 einfo "${i/*\//} unpacked"
611 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 769 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
612 else
613 eerror "Failed to unpack ${i/:*/}"
614 die "unable to unpack patch tarball"
615 fi
616 else 770 else
617 extention=${i/*./} 771 extention=${i/*./}
618 extention=${extention/:*/} 772 extention=${extention/:*/}
619 PIPE_CMD="" 773 PIPE_CMD=""
620 case ${extention} in 774 case ${extention} in
641 die Unable to locate ${i} 795 die Unable to locate ${i}
642 fi 796 fi
643 797
644 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 798 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
645 unset z 799 unset z
646 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 800 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
647 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 801 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
648 do z="${z}0"; 802 do z="${z}0";
649 done 803 done
650 PATCH_ORDER="${z}${STRICT_COUNT}" 804 PATCH_ORDER="${z}${STRICT_COUNT}"
651 805
685 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 839 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
686 840
687 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 841 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
688 while [ ${PATCH_DEPTH} -lt 5 ]; do 842 while [ ${PATCH_DEPTH} -lt 5 ]; do
689 echo "Attempting Dry-run:" >> ${STDERR_T} 843 echo "Attempting Dry-run:" >> ${STDERR_T}
690 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 844 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
691 echo "=======================================================" >> ${STDERR_T} 845 echo "=======================================================" >> ${STDERR_T}
692 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 846 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
693 echo "Attempting patch:" > ${STDERR_T} 847 echo "Attempting patch:" > ${STDERR_T}
694 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 848 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
695 echo "=======================================================" >> ${STDERR_T} 849 echo "=======================================================" >> ${STDERR_T}
696 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 850 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
697 eend 0 851 eend 0
698 rm ${STDERR_T} 852 rm ${STDERR_T}
699 break 853 break
700 else 854 else
701 eend 1 855 eend 1
713 die "Unable to dry-run patch." 867 die "Unable to dry-run patch."
714 fi 868 fi
715 done 869 done
716 done 870 done
717 871
872 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
873 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
874 # which is why I'm not taking too much time over this.
875 local tmp
876 for i in ${UNIPATCH_DOCS}; do
877 tmp="${tmp} ${i//*\/}"
878 cp -f ${i} ${T}/
879 done
880 UNIPATCH_DOCS="${tmp}"
881
718 # clean up KPATCH_DIR's - fixes bug #53610 882 # clean up KPATCH_DIR's - fixes bug #53610
719 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 883 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
720 884
721 LC_ALL="${myLC_ALL}" 885 LC_ALL="${myLC_ALL}"
886 LANG="${myLANG}"
887 eval ${extglob_bak}
722} 888}
723 889
724# getfilevar accepts 2 vars as follows: 890# getfilevar accepts 2 vars as follows:
725# getfilevar <VARIABLE> <CONFIGFILE> 891# getfilevar <VARIABLE> <CONFIGFILE>
726# pulled from linux-info 892# pulled from linux-info
735 else 901 else
736 workingdir=${PWD} 902 workingdir=${PWD}
737 basefname=$(basename ${2}) 903 basefname=$(basename ${2})
738 basedname=$(dirname ${2}) 904 basedname=$(dirname ${2})
739 unset ARCH 905 unset ARCH
740 906
741 cd ${basedname} 907 cd ${basedname}
742 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 908 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
743 make ${BUILD_FIXES} -s -f - e 2>/dev/null 909 make ${BUILD_FIXES} -s -f - e 2>/dev/null
744 cd ${workingdir} 910 cd ${workingdir}
745 911
746 ARCH=${xarch} 912 ARCH=${xarch}
747 fi 913 fi
748} 914}
749 915
750detect_arch() { 916detect_arch() {
758 # ARCH_URI is the URI for all the ${ARCH}_URI patches 924 # ARCH_URI is the URI for all the ${ARCH}_URI patches
759 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 925 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
760 926
761 ARCH_URI="" 927 ARCH_URI=""
762 ARCH_PATCH="" 928 ARCH_PATCH=""
763 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 929 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
764 930
765 for LOOP_ARCH in ${ALL_ARCH}; do 931 for LOOP_ARCH in ${ALL_ARCH}; do
766 COMPAT_URI="${LOOP_ARCH}_URI" 932 COMPAT_URI="${LOOP_ARCH}_URI"
767 COMPAT_URI="${!COMPAT_URI}" 933 COMPAT_URI="${!COMPAT_URI}"
768 934
838 return 0 1004 return 0
839} 1005}
840 1006
841headers___fix() { 1007headers___fix() {
842 # Voodoo to partially fix broken upstream headers. 1008 # Voodoo to partially fix broken upstream headers.
843 # Issues with this function should go to plasmaroo. 1009 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
844 sed -i \ 1010 sed -i \
845 -e "s/\([ "$'\t'"]\)u8\([ "$'\t'"]\)/\1__u8\2/g;" \ 1011 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
846 -e "s/\([ "$'\t'"]\)u16\([ "$'\t'"]\)/\1__u16\2/g;" \
847 -e "s/\([ "$'\t'"]\)u32\([ "$'\t'"]\)/\1__u32\2/g;" \
848 -e "s/\([ "$'\t'"]\)u64\([ "$'\t'"]\)/\1__u64\2/g;" \
849 -e "s/\([ "$'\t'"]\)s64\([ "$'\t'"]\)/\1__s64\2/g;" \
850 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1012 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
851 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1013 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1014 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1015 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
852 "$@" 1016 "$@"
853} 1017}
854 1018
855# common functions 1019# common functions
856#============================================================== 1020#==============================================================
857kernel-2_src_unpack() { 1021kernel-2_src_unpack() {
858 universal_unpack 1022 universal_unpack
1023 debug-print "Doing unipatch"
859 1024
860 [[ -n ${UNIPATCH_LIST} ]] || [[ -n ${UNIPATCH_LIST_DEFAULT} ]] && \ 1025 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
861 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1026 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1027
1028 debug-print "Doing premake"
1029
1030 # allow ebuilds to massage the source tree after patching but before
1031 # we run misc `make` functions below
1032 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1033
1034 debug-print "Doing unpack_set_extraversion"
862 1035
863 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1036 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
864 unpack_fix_docbook
865 unpack_fix_install_path 1037 unpack_fix_install_path
866 1038
1039 # Setup xmakeopts and cd into sourcetree.
1040 env_setup_xmakeopts
1041 cd "${S}"
1042
1043 # We dont need a version.h for anything other than headers
1044 # at least, I should hope we dont. If this causes problems
1045 # take out the if/fi block and inform me please.
1046 # unpack_2_6 should now be 2.6.17 safe anyways
1047 if [[ ${ETYPE} == headers ]]; then
867 kernel_is 2 4 && unpack_2_4 1048 kernel_is 2 4 && unpack_2_4
1049 kernel_is 2 6 && unpack_2_6
1050 fi
868} 1051}
869 1052
870kernel-2_src_compile() { 1053kernel-2_src_compile() {
871 cd ${S} 1054 cd "${S}"
872 [[ ${ETYPE} == headers ]] && compile_headers 1055 [[ ${ETYPE} == headers ]] && compile_headers
873 [[ ${ETYPE} == sources ]] && \
874 use doc && ! use arm && ! use s390 && compile_manpages
875} 1056}
876 1057
877kernel-2_pkg_preinst() { 1058kernel-2_pkg_preinst() {
878 [[ ${ETYPE} == headers ]] && preinst_headers 1059 [[ ${ETYPE} == headers ]] && preinst_headers
879} 1060}
888 [[ ${ETYPE} == headers ]] && postinst_headers 1069 [[ ${ETYPE} == headers ]] && postinst_headers
889 [[ ${ETYPE} == sources ]] && postinst_sources 1070 [[ ${ETYPE} == sources ]] && postinst_sources
890} 1071}
891 1072
892kernel-2_pkg_setup() { 1073kernel-2_pkg_setup() {
1074 if kernel_is 2 4; then
1075 if [ "$( gcc-major-version )" -eq "4" ] ; then
1076 echo
1077 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1078 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1079 ewarn "newer kernel that supports gcc-4."
1080 echo
1081 ewarn "Also be aware that bugreports about gcc-4 not working"
1082 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1083 echo
1084 epause 10
1085 fi
1086 fi
1087
1088 ABI="${KERNEL_ABI}"
893 [[ ${ETYPE} == headers ]] && setup_headers 1089 [[ ${ETYPE} == headers ]] && setup_headers
894 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1090 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
895} 1091}

Legend:
Removed from v.1.119  
changed lines
  Added in v.1.216

  ViewVC Help
Powered by ViewVC 1.1.20